
#include "tVal.h"
#include "ballot_def.h"
#include "candidate_def.h"
#include "party_def.h"
#include "electorate_def.h"

#define TABLE_SIZE 65536


#define error_exit(X,Y) \
printf(X,Y);\
exit(1);

enum {
    elected = 0,
    justelected = 1,
    excluded = 10,
    justexcluded = 11,
    limbo = 20,
    dead = -1
};



typedef struct elec {

    int ecode;
    
    int quota;
    int totalBallotCount;
    int totalCandidateCount;
    int totalElectorateCount;
    int totalPartyCount;
    int vacancyCount;

    int countNum;
    
    ballotList ballots[TABLE_SIZE];
    candidateDef *candidates;

    ballotList exhaustedBallots;
    
    candidateDef *orderedCandidates;

    candidateDef *alphaCandidates;
    
    partyDef *parties;
    electorateDef *electorates;
    
    int nextElectedCandidate;
    int *electedCandidates;


    char *ballotfile;
    char *candfile;
    char *partyfile;
    
    
} electionDef;

#include  "hash.h"
#include "read_input.h"
#include "print_out.h"


